classification
Title: python3.lib in Python3.9.0 Windows distribution does not contain PyObject_CallNoArgs symbol
Type: compile error Stage: resolved
Components: C API, Extension Modules, Windows Versions: Python 3.10, Python 3.9
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: David Hewitt, ZackerySpytz, alex, paul.moore, steve.dower, tim.golden, vstinner, zach.ware
Priority: normal Keywords: patch

Created on 2020-11-19 22:47 by David Hewitt, last changed 2020-12-16 21:43 by vstinner. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 23415 closed ZackerySpytz, 2020-11-20 05:56
PR 23801 merged vstinner, 2020-12-16 14:15
Messages (5)
msg381458 - (view) Author: David Hewitt (David Hewitt) Date: 2020-11-19 22:47
I'm unsure if this is a packaging error or a misunderstanding by me.

I'm trying to link a binary on windows with Py_LIMITED_API set. According to https://www.python.org/dev/peps/pep-0384/#linkage I _think_ I'm supposed to be linking against python3.lib (instead of python39.lib).

However my build fails because the PyObject_CallNoArgs symbol is not present in python3.lib

I see that the symbol is indeed present in python39.lib

Is this a misunderstanding on my part? I was under the impression that python3.lib will only contain symbols available in the limited api, and that (since 3.9) PyObject_CallNoArgs is part of the limited api.
msg381459 - (view) Author: Alex Gaynor (alex) * (Python committer) Date: 2020-11-19 23:19
This looks like a bug to me. While https://github.com/python/cpython/commit/2ff58a24e8a1c7e290d025d69ebaea0bbead3b8c added it to the header, it did not add it to https://github.com/python/cpython/blob/master/PC/python3dll.c which is required.
msg381460 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2020-11-20 00:51
Yeah, this will be our fault.

Someone is looking into automatically generating the .def file so that this stops happening. Last time we tried that there was a lot of pushback because "too many APIs will become stable", but this time I think we're just going to force those devs to care for their APIs properly.

(I'm blanking right now on who was working on this... anyone remember?)
msg383170 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-12-16 14:17
commit fcc6935384b933fbe1a1ef659ed455a3b74c849a
Author: Victor Stinner <vstinner@python.org>
Date:   Wed Dec 16 15:08:23 2020 +0100

    Add symbols of the stable ABI to python3dll.c (GH-23598)
    
    Add the following symbols to python3dll.c:
    
    * PyFrame_GetCode (bpo-40421)
    * PyFrame_GetLineNumber (bpo-40421)
    * PyModule_AddObjectRef (bpo-1635741)
    * PyObject_CallNoArgs (bpo-37194)
    * PyThreadState_GetFrame (bpo-39947)
    * PyThreadState_GetID (bpo-39947)
    * PyThreadState_GetInterpreter (bpo-39947)

I backported the change manually to 3.9: PR 23801.
msg383211 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-12-16 21:43
Thanks David Hewitt for the bug report, and Zackery Spytz for your fix!

3.9 fix:

commit 166286849048eccadecf02b242dbc4042b780944
Author: Victor Stinner <vstinner@python.org>
Date:   Wed Dec 16 22:41:47 2020 +0100

    Add symbols of the stable ABI to python3dll.c (GH-23598) (GH-23801)
    
    Add the following symbols to python3dll.c:
    
    * PyFrame_GetCode (bpo-40421)
    * PyFrame_GetLineNumber (bpo-40421)
    * PyObject_CallNoArgs (bpo-37194)
    * PyThreadState_GetFrame (bpo-39947)
    * PyThreadState_GetID (bpo-39947)
    * PyThreadState_GetInterpreter (bpo-39947)
    
    (cherry picked from commit fcc6935384b933fbe1a1ef659ed455a3b74c849a)
History
Date User Action Args
2020-12-16 21:43:38vstinnersetstatus: open -> closed
resolution: fixed
messages: + msg383211

stage: patch review -> resolved
2020-12-16 14:17:17vstinnersetmessages: + msg383170
2020-12-16 14:15:17vstinnersetnosy: + vstinner
pull_requests: + pull_request22658
2020-11-20 05:56:16ZackerySpytzsetkeywords: + patch
nosy: + ZackerySpytz

pull_requests: + pull_request22308
stage: patch review
2020-11-20 01:01:11alexsetversions: + Python 3.10
2020-11-20 01:01:02alexsetcomponents: + C API
2020-11-20 00:51:49steve.dowersetmessages: + msg381460
2020-11-19 23:19:31alexsetnosy: + alex
messages: + msg381459
components: + Extension Modules
2020-11-19 22:47:45David Hewittcreate